package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.String;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.util.ArrayList;
import java.lang.Object;

public class CapabilitiesFluentImpl<A extends CapabilitiesFluent<A>> extends BaseFluent<A> implements CapabilitiesFluent<A>{

    private List<String> add = new ArrayList<String>();
    private List<String> drop = new ArrayList<String>();

    public CapabilitiesFluentImpl(){
    }
    public CapabilitiesFluentImpl(Capabilities instance){
            this.withAdd(instance.getAdd()); 
            this.withDrop(instance.getDrop()); 
    }

    public A addToAdd(String... items){
            for (String item : items) {this.add.add(item);} return (A)this;
    }

    public A removeFromAdd(String... items){
            for (String item : items) {this.add.remove(item);} return (A)this;
    }

    public List<String> getAdd(){
            return this.add;
    }

    public A withAdd(List<String> add){
            this.add.clear();
            if (add != null) {for (String item : add){this.addToAdd(item);}} return (A) this;
    }

    public A withAdd(String... add){
            this.add.clear(); if (add != null) {for (String item :add){ this.addToAdd(item);}} return (A) this;
    }

    public A addToDrop(String... items){
            for (String item : items) {this.drop.add(item);} return (A)this;
    }

    public A removeFromDrop(String... items){
            for (String item : items) {this.drop.remove(item);} return (A)this;
    }

    public List<String> getDrop(){
            return this.drop;
    }

    public A withDrop(List<String> drop){
            this.drop.clear();
            if (drop != null) {for (String item : drop){this.addToDrop(item);}} return (A) this;
    }

    public A withDrop(String... drop){
            this.drop.clear(); if (drop != null) {for (String item :drop){ this.addToDrop(item);}} return (A) this;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            CapabilitiesFluentImpl that = (CapabilitiesFluentImpl) o;
            if (add != null ? !add.equals(that.add) :that.add != null) return false;
            if (drop != null ? !drop.equals(that.drop) :that.drop != null) return false;
            return true;
    }




}
