package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.String;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.util.ArrayList;
import java.lang.Object;

public class RootPathsFluentImpl<A extends RootPathsFluent<A>> extends BaseFluent<A> implements RootPathsFluent<A>{

    private List<String> paths = new ArrayList<String>();

    public RootPathsFluentImpl(){
    }
    public RootPathsFluentImpl(RootPaths instance){
            this.withPaths(instance.getPaths()); 
    }

    public A addToPaths(String... items){
            for (String item : items) {this.paths.add(item);} return (A)this;
    }

    public A removeFromPaths(String... items){
            for (String item : items) {this.paths.remove(item);} return (A)this;
    }

    public List<String> getPaths(){
            return this.paths;
    }

    public A withPaths(List<String> paths){
            this.paths.clear();
            if (paths != null) {for (String item : paths){this.addToPaths(item);}} return (A) this;
    }

    public A withPaths(String... paths){
            this.paths.clear(); if (paths != null) {for (String item :paths){ this.addToPaths(item);}} return (A) this;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            RootPathsFluentImpl that = (RootPathsFluentImpl) o;
            if (paths != null ? !paths.equals(that.paths) :that.paths != null) return false;
            return true;
    }




}
