package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.String;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.lang.Object;

public class SecretKeySelectorFluentImpl<A extends SecretKeySelectorFluent<A>> extends BaseFluent<A> implements SecretKeySelectorFluent<A>{

    private String key;
    private String name;

    public SecretKeySelectorFluentImpl(){
    }
    public SecretKeySelectorFluentImpl(SecretKeySelector instance){
            this.withKey(instance.getKey()); 
            this.withName(instance.getName()); 
    }

    public String getKey(){
            return this.key;
    }

    public A withKey(String key){
            this.key=key; return (A) this;
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            SecretKeySelectorFluentImpl that = (SecretKeySelectorFluentImpl) o;
            if (key != null ? !key.equals(that.key) :that.key != null) return false;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            return true;
    }




}
