package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.String;
import javax.validation.constraints.NotNull;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.util.List;
import javax.validation.Valid;
import io.fabric8.kubernetes.api.model.ListMeta;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.fabric8.kubernetes.api.builder.Nested;
import io.fabric8.kubernetes.api.model.ListMetaFluent;
import io.fabric8.kubernetes.api.model.ListMetaBuilder;

public interface BuildConfigListFluent<A extends BuildConfigListFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public A addToItems(BuildConfig... items);
    public A removeFromItems(BuildConfig... items);
    public List<BuildConfig> getItems();
    public A withItems(List<BuildConfig> items);
    public A withItems(BuildConfig... items);
    public BuildConfigListFluent.ItemsNested<A> addNewItem();
    public BuildConfigListFluent.ItemsNested<A> addNewItemLike(BuildConfig item);
    public String getKind();
    public A withKind(String kind);
    public ListMeta getMetadata();
    public A withMetadata(ListMeta metadata);
    public BuildConfigListFluent.MetadataNested<A> withNewMetadata();
    public BuildConfigListFluent.MetadataNested<A> withNewMetadataLike(ListMeta item);
    public BuildConfigListFluent.MetadataNested<A> editMetadata();
    public A withNewMetadata(String resourceVersion,String selfLink);

    public interface ItemsNested<N> extends Nested<N>,BuildConfigFluent<BuildConfigListFluent.ItemsNested<N>>{

        
    public N endItem();    public N and();
}
    public interface MetadataNested<N> extends Nested<N>,ListMetaFluent<BuildConfigListFluent.MetadataNested<N>>{

        
    public N and();    public N endMetadata();
}


}
