package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.String;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.lang.Object;

public class KeyToPathFluentImpl<A extends KeyToPathFluent<A>> extends BaseFluent<A> implements KeyToPathFluent<A>{

    private String key;
    private String path;

    public KeyToPathFluentImpl(){
    }
    public KeyToPathFluentImpl(KeyToPath instance){
            this.withKey(instance.getKey()); 
            this.withPath(instance.getPath()); 
    }

    public String getKey(){
            return this.key;
    }

    public A withKey(String key){
            this.key=key; return (A) this;
    }

    public String getPath(){
            return this.path;
    }

    public A withPath(String path){
            this.path=path; return (A) this;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            KeyToPathFluentImpl that = (KeyToPathFluentImpl) o;
            if (key != null ? !key.equals(that.key) :that.key != null) return false;
            if (path != null ? !path.equals(that.path) :that.path != null) return false;
            return true;
    }




}
