
package io.fabric8.kubernetes.api.model;

import java.util.HashMap;
import java.util.Map;
import javax.annotation.Generated;
import javax.validation.Valid;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import io.fabric8.kubernetes.api.model.Doneable;
import io.sundr.builder.annotations.Buildable;
import io.sundr.builder.annotations.Inline;
import lombok.EqualsAndHashCode;
import lombok.ToString;


/**
 * 
 * 
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@Generated("org.jsonschema2pojo")
@JsonPropertyOrder({
    "apiVersion",
    "kind",
    "metadata",
    "postStart",
    "preStop"
})
@JsonDeserialize(using = com.fasterxml.jackson.databind.JsonDeserializer.None.class)
@ToString
@EqualsAndHashCode
@Buildable(editableEnabled = false, validationEnabled = true, generateBuilderPackage = true, builderPackage = "io.fabric8.kubernetes.api.builder", inline = @Inline(type = Doneable.class, prefix = "Doneable", value = "done"))
public class Lifecycle implements KubernetesResource
{

    /**
     * 
     * 
     */
    @JsonProperty("postStart")
    @Valid
    private Handler postStart;
    /**
     * 
     * 
     */
    @JsonProperty("preStop")
    @Valid
    private Handler preStop;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();

    /**
     * No args constructor for use in serialization
     * 
     */
    public Lifecycle() {
    }

    /**
     * 
     * @param postStart
     * @param preStop
     */
    public Lifecycle(Handler postStart, Handler preStop) {
        this.postStart = postStart;
        this.preStop = preStop;
    }

    /**
     * 
     * 
     * @return
     *     The postStart
     */
    @JsonProperty("postStart")
    public Handler getPostStart() {
        return postStart;
    }

    /**
     * 
     * 
     * @param postStart
     *     The postStart
     */
    @JsonProperty("postStart")
    public void setPostStart(Handler postStart) {
        this.postStart = postStart;
    }

    /**
     * 
     * 
     * @return
     *     The preStop
     */
    @JsonProperty("preStop")
    public Handler getPreStop() {
        return preStop;
    }

    /**
     * 
     * 
     * @param preStop
     *     The preStop
     */
    @JsonProperty("preStop")
    public void setPreStop(Handler preStop) {
        this.preStop = preStop;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

}
