package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.BaseFluent;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.lang.String;
import java.lang.Object;

public class NamedExtensionFluentImpl<A extends NamedExtensionFluent<A>> extends BaseFluent<A> implements NamedExtensionFluent<A>{

    private HasMetadata extension;
    private String name;

    public NamedExtensionFluentImpl(){
    }
    public NamedExtensionFluentImpl(NamedExtension instance){
            this.withExtension(instance.getExtension()); 
            this.withName(instance.getName()); 
    }

    public HasMetadata getExtension(){
            return this.extension;
    }

    public A withExtension(HasMetadata extension){
            this.extension=extension; return (A) this;
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            NamedExtensionFluentImpl that = (NamedExtensionFluentImpl) o;
            if (extension != null ? !extension.equals(that.extension) :that.extension != null) return false;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            return true;
    }




}
