
package io.fabric8.kubernetes.api.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;
import javax.validation.Valid;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import io.fabric8.kubernetes.api.model.Doneable;
import io.sundr.builder.annotations.Buildable;
import io.sundr.builder.annotations.Inline;
import lombok.EqualsAndHashCode;
import lombok.ToString;


/**
 * 
 * 
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@Generated("org.jsonschema2pojo")
@JsonPropertyOrder({
    "apiVersion",
    "kind",
    "metadata",
    "ranges",
    "type"
})
@JsonDeserialize(using = com.fasterxml.jackson.databind.JsonDeserializer.None.class)
@ToString
@EqualsAndHashCode
@Buildable(editableEnabled = false, validationEnabled = true, generateBuilderPackage = true, builderPackage = "io.fabric8.kubernetes.api.builder", inline = @Inline(type = Doneable.class, prefix = "Doneable", value = "done"))
public class SupplementalGroupsStrategyOptions implements KubernetesResource
{

    /**
     * ranges of allowable IDs for supplemental groups
     * 
     */
    @JsonProperty("ranges")
    @Valid
    private List<IDRange> ranges = new ArrayList<IDRange>();
    /**
     * strategy used to generate supplemental groups
     * 
     */
    @JsonProperty("type")
    private String type;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();

    /**
     * No args constructor for use in serialization
     * 
     */
    public SupplementalGroupsStrategyOptions() {
    }

    /**
     * 
     * @param ranges
     * @param type
     */
    public SupplementalGroupsStrategyOptions(List<IDRange> ranges, String type) {
        this.ranges = ranges;
        this.type = type;
    }

    /**
     * ranges of allowable IDs for supplemental groups
     * 
     * @return
     *     The ranges
     */
    @JsonProperty("ranges")
    public List<IDRange> getRanges() {
        return ranges;
    }

    /**
     * ranges of allowable IDs for supplemental groups
     * 
     * @param ranges
     *     The ranges
     */
    @JsonProperty("ranges")
    public void setRanges(List<IDRange> ranges) {
        this.ranges = ranges;
    }

    /**
     * strategy used to generate supplemental groups
     * 
     * @return
     *     The type
     */
    @JsonProperty("type")
    public String getType() {
        return type;
    }

    /**
     * strategy used to generate supplemental groups
     * 
     * @param type
     *     The type
     */
    @JsonProperty("type")
    public void setType(String type) {
        this.type = type;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

}
