package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.String;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import io.fabric8.kubernetes.api.model.EnvVar;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.fabric8.kubernetes.api.builder.Nested;
import io.fabric8.kubernetes.api.model.EnvVarFluent;
import io.fabric8.kubernetes.api.model.EnvVarBuilder;

public interface ExecNewPodHookFluent<A extends ExecNewPodHookFluent<A>> extends Fluent<A>{


    public A addToCommand(String... items);
    public A removeFromCommand(String... items);
    public List<String> getCommand();
    public A withCommand(List<String> command);
    public A withCommand(String... command);
    public String getContainerName();
    public A withContainerName(String containerName);
    public A addToEnv(EnvVar... items);
    public A removeFromEnv(EnvVar... items);
    public List<EnvVar> getEnv();
    public A withEnv(List<EnvVar> env);
    public A withEnv(EnvVar... env);
    public ExecNewPodHookFluent.EnvNested<A> addNewEnv();
    public ExecNewPodHookFluent.EnvNested<A> addNewEnvLike(EnvVar item);
    public A addToVolumes(String... items);
    public A removeFromVolumes(String... items);
    public List<String> getVolumes();
    public A withVolumes(List<String> volumes);
    public A withVolumes(String... volumes);

    public interface EnvNested<N> extends Nested<N>,EnvVarFluent<ExecNewPodHookFluent.EnvNested<N>>{

        
    public N endEnv();    public N and();
}


}
