package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.lang.String;
import java.util.List;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.fabric8.kubernetes.api.builder.Nested;

public interface LifecycleHookFluent<A extends LifecycleHookFluent<A>> extends Fluent<A>{


    public ExecNewPodHook getExecNewPod();
    public A withExecNewPod(ExecNewPodHook execNewPod);
    public LifecycleHookFluent.ExecNewPodNested<A> withNewExecNewPod();
    public LifecycleHookFluent.ExecNewPodNested<A> withNewExecNewPodLike(ExecNewPodHook item);
    public LifecycleHookFluent.ExecNewPodNested<A> editExecNewPod();
    public String getFailurePolicy();
    public A withFailurePolicy(String failurePolicy);
    public A addToTagImages(TagImageHook... items);
    public A removeFromTagImages(TagImageHook... items);
    public List<TagImageHook> getTagImages();
    public A withTagImages(List<TagImageHook> tagImages);
    public A withTagImages(TagImageHook... tagImages);
    public LifecycleHookFluent.TagImagesNested<A> addNewTagImage();
    public LifecycleHookFluent.TagImagesNested<A> addNewTagImageLike(TagImageHook item);

    public interface ExecNewPodNested<N> extends Nested<N>,ExecNewPodHookFluent<LifecycleHookFluent.ExecNewPodNested<N>>{

        
    public N and();    public N endExecNewPod();
}
    public interface TagImagesNested<N> extends Nested<N>,TagImageHookFluent<LifecycleHookFluent.TagImagesNested<N>>{

        
    public N and();    public N endTagImage();
}


}
