package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import java.lang.String;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.lang.Long;
import io.fabric8.kubernetes.api.builder.Nested;

public interface NamedTagEventListFluent<A extends NamedTagEventListFluent<A>> extends Fluent<A>{


    public A addToConditions(TagEventCondition... items);
    public A removeFromConditions(TagEventCondition... items);
    public List<TagEventCondition> getConditions();
    public A withConditions(List<TagEventCondition> conditions);
    public A withConditions(TagEventCondition... conditions);
    public NamedTagEventListFluent.ConditionsNested<A> addNewCondition();
    public NamedTagEventListFluent.ConditionsNested<A> addNewConditionLike(TagEventCondition item);
    public A addToItems(TagEvent... items);
    public A removeFromItems(TagEvent... items);
    public List<TagEvent> getItems();
    public A withItems(List<TagEvent> items);
    public A withItems(TagEvent... items);
    public NamedTagEventListFluent.ItemsNested<A> addNewItem();
    public NamedTagEventListFluent.ItemsNested<A> addNewItemLike(TagEvent item);
    public A addNewItem(String created,String dockerImageReference,Long generation,String image);
    public String getTag();
    public A withTag(String tag);

    public interface ConditionsNested<N> extends Nested<N>,TagEventConditionFluent<NamedTagEventListFluent.ConditionsNested<N>>{

        
    public N endCondition();    public N and();
}
    public interface ItemsNested<N> extends Nested<N>,TagEventFluent<NamedTagEventListFluent.ItemsNested<N>>{

        
    public N endItem();    public N and();
}


}
