package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.String;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;
import javax.validation.Valid;
import io.fabric8.kubernetes.api.model.HasMetadata;
import java.lang.Object;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonIgnore;

public interface PolicyRuleFluent<A extends PolicyRuleFluent<A>> extends Fluent<A>{


    public A addToApiGroups(String... items);
    public A removeFromApiGroups(String... items);
    public List<String> getApiGroups();
    public A withApiGroups(List<String> apiGroups);
    public A withApiGroups(String... apiGroups);
    public HasMetadata getAttributeRestrictions();
    public A withAttributeRestrictions(HasMetadata attributeRestrictions);
    public A addToNonResourceURLs(String... items);
    public A removeFromNonResourceURLs(String... items);
    public List<String> getNonResourceURLs();
    public A withNonResourceURLs(List<String> nonResourceURLs);
    public A withNonResourceURLs(String... nonResourceURLs);
    public A addToResourceNames(String... items);
    public A removeFromResourceNames(String... items);
    public List<String> getResourceNames();
    public A withResourceNames(List<String> resourceNames);
    public A withResourceNames(String... resourceNames);
    public A addToResources(String... items);
    public A removeFromResources(String... items);
    public List<String> getResources();
    public A withResources(List<String> resources);
    public A withResources(String... resources);
    public A addToVerbs(String... items);
    public A removeFromVerbs(String... items);
    public List<String> getVerbs();
    public A withVerbs(List<String> verbs);
    public A withVerbs(String... verbs);



}
